;--------------------------------------------------
;TruuuC - http://galerie.truuuc.com/
;http://www.maxthon-fr.com/
;NSIS & HM NIS Edit
;--------------------------------------------------

; Product
!define PRODUCT_NAME "Mx_Fr_Updater"
!define PRODUCT_VERSION "$MxVersion"
!define PRODUCT_PUBLISHER "Maxthon"
!define PRODUCT_WEB_SITE "http://fr.maxthon.com/"

; MUI 1.67 compatible
!include "MUI.nsh"
!include "InstallOptions.nsh"
!include "WordFunc.nsh"
!include "WinVer.nsh"
!include "XML.nsh"

ReserveFile "${NSISDIR}\Plugins\x86-ansi\InstallOptions.dll"
ReserveFile "${PRODUCT_NAME}.ini"

; MUI Settings
;!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install-blue-full.ico"

; Welcome page
;!insertmacro MUI_PAGE_WELCOME
; Directory page
!define MUI_PAGE_HEADER_TEXT "Maxthon French Updater"
!define MUI_PAGE_HEADER_SUBTEXT "Outil de mise  jour franais pour Maxthon"
;!define MUI_DIRECTORYPAGE_TEXT_TOP ""
;!insertmacro MUI_PAGE_DIRECTORY
; Custom page
Page Custom ShowCustom LeaveCustom
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
;!insertmacro MUI_PAGE_FINISH
; Language files
!insertmacro MUI_LANGUAGE "French"

; MUI end ------

# Variables
var MxVersion
var WinFlashDLLPath
var WinFlashVersion
var AbFlashAxVersion
var AbFlashPlgVersion
var AbFlashPepVersion
var MxFlashVersion
var MxFlashDLLName

# Display
Name "${PRODUCT_NAME} - ${PRODUCT_PUBLISHER}" ;Nom affich dans l'installateur (barre de titre...).
OutFile "${PRODUCT_NAME}.exe"
InstallDir "$PROGRAMFILES\Maxthon" ;Rpertoire d'installation par dfaut.
;Rpertoire d'installation de Maxthon dans le registre (si vide, utilise le rpertoire par dfaut).
InstallDirRegKey HKCU "SOFTWARE\Maxthon3" "Folder"
InstallDirRegKey HKCU "SOFTWARE\Maxthon5" "Folder"
ShowInstDetails show
AutoCloseWindow false

Function .onInit
;Extraire les fichiers InstallOptions.
  !insertmacro INSTALLOPTIONS_EXTRACT "${PRODUCT_NAME}.ini"
;Rcuprer le rpertoire d'installation par dfaut de Maxthon.
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 13" "State" "$INSTDIR"
;Rcuprer le rpertoire d'installation sauvegard si le fichier de sauvegarde existe.
  IfFileExists '$APPDATA\Maxthon5\${PRODUCT_NAME}.ini' 0 +5
  ReadINIStr $6 "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} InstDir
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 13" "State" "$6"
  !insertmacro INSTALLOPTIONS_READ $INSTDIR "${PRODUCT_NAME}.ini" "Field 13" "State"
  Goto MxVersion
  IfFileExists '$APPDATA\Maxthon3\${PRODUCT_NAME}.ini' 0 MxVersion
  ReadINIStr $6 "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} InstDir
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 13" "State" "$6"
  !insertmacro INSTALLOPTIONS_READ $INSTDIR "${PRODUCT_NAME}.ini" "Field 13" "State"

MxVersion:
;Dfinir la version de Maxthon.
  SetRegView 32
  GetDLLVersion $INSTDIR\Bin\Maxthon.exe $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $1 "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version de Maxthon : $1"
  ${VersionCompare} "$1" "5.0.0.0000" $2
  StrCmp $2 "1" MX5 MX4

MX5:
;Charger les paramtres sauvegards si le fichier de sauvegarde existe.
  IfFileExists '$APPDATA\Maxthon5\${PRODUCT_NAME}.ini' 0 DoneMx5
  ReadINIStr $1 "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelTrad
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 4" "State" "$1"
  ReadINIStr $3 "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} RunMx
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 8" "State" "$3"
  ReadINIStr $4 "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} CloseWindow
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 9" "State" "$4"
  ReadINIStr $5 "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} SaveOptions
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 10" "State" "$5"

DoneMx5:
  StrCpy $MxVersion "5"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "State" "0"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "Flags" "DISABLED" ;Dsactiver la fonction de suppresion de la DLL Flash Player, inutilisable pour Maxthon 5.
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 6" "State" "0"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 6" "Flags" "DISABLED" ;Dsactiver la fonction de suppresion de la DLL PDF, inutilisable pour Maxthon 5.
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 11" "State" "1" ;Cocher par dfaut la non installation des traductions, inutile pour Maxthon 5.
  Goto End
  
MX4:
;Charger les paramtres sauvegards si le fichier de sauvegarde existe.
  IfFileExists '$APPDATA\Maxthon3\${PRODUCT_NAME}.ini' 0 DoneMx4
  ReadINIStr $1 "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelTrad
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 4" "State" "$1"
  ReadINIStr $2 "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelPDF
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 6" "State" "$2"
  ReadINIStr $3 "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} RunMx
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 8" "State" "$3"
  ReadINIStr $4 "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} CloseWindow
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 9" "State" "$4"
  ReadINIStr $5 "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} SaveOptions
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 10" "State" "$5"

DoneMx4:
  ;Dfinir la sous-version de Maxthon 4.
  SetRegView 32
  GetDLLVersion $INSTDIR\Bin\Maxthon.exe $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $1 "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Sous-version de Maxthon 4 : $1"
  ${VersionCompare} "$1" "4.8.8.8000" $2
  StrCmp $2 "1" NG Cloud

NG:
  StrCpy $MxVersion "NG"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "State" "0"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "Flags" "DISABLED" ;Dsactiver la fonction de suppresion de la DLL Flash Player, inutilisable pour Maxthon NG.
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 11" "State" "1" ;Cocher par dfaut la non installation des traductions, inutile pour Maxthon NG.
  Goto End

Cloud:
  StrCpy $MxVersion "Cloud"
  ;Charger les paramtres sauvegards si le fichier de sauvegarde existe.
  IfFileExists '$APPDATA\Maxthon3\${PRODUCT_NAME}.ini' 0 End
  ReadINIStr $2 "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelFlash
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "State" "$2"

End:
FunctionEnd

Function ShowCustom
;Initialiser la fentre Maxthon Update.
  !insertmacro MUI_HEADER_TEXT "Maxthon French Updater" "Outil de mise  jour franais pour Maxthon ${PRODUCT_VERSION}"
  !insertmacro INSTALLOPTIONS_DISPLAY "${PRODUCT_NAME}.ini"
FunctionEnd

Function LeaveCustom
;Lire le rpertoire d'installation saisi.
  !insertmacro INSTALLOPTIONS_READ $INSTDIR "${PRODUCT_NAME}.ini" "Field 13" "State"
  
;Redfinir la version de Maxthon en cas de changement du rpertoire d'installation.
  IfFileExists '$INSTDIR\Bin\Maxthon.exe' 0 Fail
  SetRegView 32
  GetDLLVersion $INSTDIR\Bin\Maxthon.exe $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $1 "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version de Maxthon : $1"
  ${VersionCompare} "$1" "5.0.0.0000" $2
  StrCmp $2 "1" MX5 MX4

MX5:
  StrCpy $MxVersion "5"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "State" "0"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "Flags" "DISABLED" ;Dsactiver la fonction de suppresion de la DLL Flash Player, inutilisable pour Maxthon 5.
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 11" "State" "1" ;Cocher par dfaut la non installation des traductions, inutile pour Maxthon 5.
  Goto DoneMX5

MX4:
  ;MessageBox MB_ICONINFORMATION|MB_OK "Sous-version de Maxthon 4 : $1"
  ${VersionCompare} "$1" "4.8.8.8000" $2
  StrCmp $2 "1" NG Cloud

NG:
  StrCpy $MxVersion "NG"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "State" "0"
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "Flags" "DISABLED" ;Dsactiver la fonction de suppresion de la DLL Flash Player, inutilisable pour Maxthon NG.
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 11" "State" "1" ;Cocher par dfaut la non installation des traductions, inutile pour Maxthon NG.
  Goto DoneMX4

Cloud:
  StrCpy $MxVersion "Cloud"
;Charger les paramtres sauvegards si le fichier de sauvegarde existe.
  IfFileExists '$APPDATA\Maxthon3\${PRODUCT_NAME}.ini' 0 DoneMX4
  ReadINIStr $2 "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelFlash
  !insertmacro INSTALLOPTIONS_WRITE "${PRODUCT_NAME}.ini" "Field 5" "State" "$2"
  Goto DoneMX4

Fail:
;Maxthon.exe introuvable.
  MessageBox MB_OK|MB_ICONEXCLAMATION "Maxthon.exe n'a pas t trouv dans $INSTDIR\Bin." 
  Abort

DoneMX5:  
;Sauvegarder les paramtres si l'option est active.
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 10" "State"
  StrCmp $0 1 0 End
  !insertmacro INSTALLOPTIONS_READ $1 "${PRODUCT_NAME}.ini" "Field 4" "State"
  WriteINIStr "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelTrad "$1"
  !insertmacro INSTALLOPTIONS_READ $2 "${PRODUCT_NAME}.ini" "Field 5" "State"
  WriteINIStr "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelFlash "$2"
  !insertmacro INSTALLOPTIONS_READ $3 "${PRODUCT_NAME}.ini" "Field 6" "State"
  WriteINIStr "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelPDF "$3"
  !insertmacro INSTALLOPTIONS_READ $4 "${PRODUCT_NAME}.ini" "Field 8" "State"
  WriteINIStr "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} RunMx "$4"
  !insertmacro INSTALLOPTIONS_READ $5 "${PRODUCT_NAME}.ini" "Field 9" "State"
  WriteINIStr "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} CloseWindow "$5"
  !insertmacro INSTALLOPTIONS_READ $6 "${PRODUCT_NAME}.ini" "Field 10" "State"
  WriteINIStr "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} SaveOptions "$6"
  !insertmacro INSTALLOPTIONS_READ $7 "${PRODUCT_NAME}.ini" "Field 13" "State"
  WriteINIStr "$APPDATA\Maxthon5\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} InstDir "$7"
  Goto End

DoneMX4:  
;Sauvegarder les paramtres si l'option est active.
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 10" "State"
  StrCmp $0 1 0 End
  !insertmacro INSTALLOPTIONS_READ $1 "${PRODUCT_NAME}.ini" "Field 4" "State"
  WriteINIStr "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelTrad "$1"
  !insertmacro INSTALLOPTIONS_READ $2 "${PRODUCT_NAME}.ini" "Field 5" "State"
  WriteINIStr "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelFlash "$2"
  !insertmacro INSTALLOPTIONS_READ $3 "${PRODUCT_NAME}.ini" "Field 6" "State"
  WriteINIStr "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} DelPDF "$3"
  !insertmacro INSTALLOPTIONS_READ $4 "${PRODUCT_NAME}.ini" "Field 8" "State"
  WriteINIStr "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} RunMx "$4"
  !insertmacro INSTALLOPTIONS_READ $5 "${PRODUCT_NAME}.ini" "Field 9" "State"
  WriteINIStr "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} CloseWindow "$5"
  !insertmacro INSTALLOPTIONS_READ $6 "${PRODUCT_NAME}.ini" "Field 10" "State"
  WriteINIStr "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} SaveOptions "$6"
  !insertmacro INSTALLOPTIONS_READ $7 "${PRODUCT_NAME}.ini" "Field 13" "State"
  WriteINIStr "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini" ${PRODUCT_NAME} InstDir "$7"

End:
;Activer la fermeture automatique de la fentre si l'option est active.
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 9" "State"
  StrCmp $0 1 0 +2
  SetAutoClose true
FunctionEnd

Section InstallFiles
  SetDetailsPrint none
  CreateDirectory "$TEMP\${PRODUCT_NAME}"
  SetDetailsPrint both

  StrCmp $MxVersion "5" Mx5FlashVersion 0
  StrCmp $MxVersion "NG" MxNGFlashVersion MxCloudFlashVersion

Mx5FlashVersion:
;Dfninir la version d'Adobe Flash Player intgr  Maxthon 5.
  FindFirst $3 $MxFlashDLLName $INSTDIR\Core\plugins\pepflash*.dll
  ;MessageBox MB_ICONINFORMATION|MB_OK "Nom DLL Flash Player Maxthon 5 : $MxFlashDLLName"
  FindClose $3
  GetDLLVersion $INSTDIR\Core\plugins\$MxFlashDLLName $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $MxFlashVersion "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version DLL Flash Player Maxthon 5 : $MxFlashVersion"
  Goto AdobeFlashVersion

MxNGFlashVersion:
;Dfninir la version d'Adobe Flash Player intgr  Maxthon NG.
  FindFirst $3 $MxFlashDLLName $INSTDIR\Core\Blink\plugins\pepflash*.dll
  ;MessageBox MB_ICONINFORMATION|MB_OK "Nom DLL Flash Player Maxthon NG : $MxFlashDLLName"
  FindClose $3
  GetDLLVersion $INSTDIR\Core\Blink\plugins\$MxFlashDLLName $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $MxFlashVersion "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version DLL Flash Player Maxthon NG : $MxFlashVersion"
  Goto AdobeFlashVersion

MxCloudFlashVersion:
;Dfninir la version du plugin Adobe Flash Player intgr  Maxthon Cloud.
  FindFirst $3 $MxFlashDLLName $INSTDIR\Core\Webkit\Npplugins\NPSWF*.dll
  ;MessageBox MB_ICONINFORMATION|MB_OK "Nom DLL Flash Player Maxthon Cloud : $MxFlashDLLName"
  FindClose $3
  GetDLLVersion $INSTDIR\Core\Webkit\Npplugins\$MxFlashDLLName $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $MxFlashVersion "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version DLL Flash Player Maxthon Cloud : $MxFlashVersion"

AdobeFlashVersion:
;Rcuprer la dernire version d'Adoble Flash Player disponible sur Adobe.com
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 3" "State"
  StrCmp $0 1 0 DelTrad

  NSISdl::download https://fpdownload.adobe.com/get/flashplayer/update/current/sau/11/xml/version.xml "$TEMP\${PRODUCT_NAME}\version.xml"
  ${xml::LoadFile} "$TEMP\${PRODUCT_NAME}\version.xml" $0
  StrCmp $0 "-1" AdobeFlash
  ${xml::GotoPath} "/version/ActiveX" $0
  ${xml::FirstAttribute} $5 $1 $0
  ${xml::NextAttribute} $5 $2 $0
  ${xml::NextAttribute} $5 $3 $0
  ${xml::LastAttribute} $5 $4 $0
  StrCpy $AbFlashAxVersion "$1.$2.$3.$4"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version Flash Player ActiveX Adobe.com : $AbFlashAxVersion"
  ${xml::GotoPath} "/version/Plugin" $0
  ${xml::FirstAttribute} $5 $1 $0
  ${xml::NextAttribute} $5 $2 $0
  ${xml::NextAttribute} $5 $3 $0
  ${xml::LastAttribute} $5 $4 $0
  StrCpy $AbFlashPlgVersion "$1.$2.$3.$4"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version Flash Player Plugin Adobe.com : $AbFlashPlgVersion"
  ${xml::GotoPath} "/version/Pepper" $0
  ${xml::FirstAttribute} $5 $1 $0
  ${xml::NextAttribute} $5 $2 $0
  ${xml::NextAttribute} $5 $3 $0
  ${xml::LastAttribute} $5 $4 $0
  StrCpy $AbFlashPepVersion "$1.$2.$3.$4"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version Flash Player Pepper Adobe.com : $AbFlashPepVersion"
  ${xml::NodeHandle} $0
  ${xml::Unload}

AdobeFlash:
;Tlchargement et installation d'Adobe Flash Player.
  StrCmp $MxVersion "Cloud" NPAPI PPAPI

PPAPI:
;Adobe Flash Player PPAPI pour Maxthon 5 et Maxthon NG
  SetRegView 32
  ReadRegStr $WinFlashDLLPath HKLM "SOFTWARE\Macromedia\FlashPlayerPepper" "PlayerPath"
  GetDLLVersion $WinFlashDLLPath $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $WinFlashVersion "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version DLL Flash Player PPAPI Windows : $WinFlashVersion"
  ${VersionCompare} "$AbFlashPepVersion" "$WinFlashVersion" $1
  StrCmp $1 "0" 0 +4
  DetailPrint "Tlchargement d'Adobe Flash Player PPAPI inutile"
  DetailPrint "La dernire version $WinFlashVersion est dj installe"
  Goto ActiveX
  DetailPrint "Tlchargement d'Adobe Flash Player PPAPI"
  NSISdl::download http://fpdownload.adobe.com/get/flashplayer/latest/help/install_flash_player_ppapi.exe "$TEMP\${PRODUCT_NAME}\install_flash_player_ppapi.exe"
  Pop $R0 ;Get the return value.
  StrCmp $R0 "success" +4
  MessageBox MB_OK "Erreur de tlchargement d'Adobe Flash Player PPAPI : $R0"
  DetailPrint "Erreur de tlchargement d'Adobe Flash Player PPAPI : $R0"
  Goto ActiveX
  ExecWait '"$TEMP\${PRODUCT_NAME}\install_flash_player_ppapi.exe"'
  Goto ActiveX

NPAPI:
;Adobe Flash Player NPAPI pour Maxthon Cloud
  SetRegView 32
  ReadRegStr $WinFlashDLLPath HKLM "SOFTWARE\Macromedia\FlashPlayerPlugin" "PlayerPath"
  GetDLLVersion $WinFlashDLLPath $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $WinFlashVersion "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version DLL Flash Player NPAPI Windows : $WinFlashVersion"
  ${VersionCompare} "$AbFlashPlgVersion" "$WinFlashVersion" $1
  StrCmp $1 "0" 0 +4
  DetailPrint "Tlchargement d'Adobe Flash Player NPAPI inutile"
  DetailPrint "La dernire version $WinFlashVersion est dj installe"
  Goto ActiveX
  DetailPrint "Tlchargement d'Adobe Flash Player NPAPI"
  NSISdl::download http://fpdownload.adobe.com/get/flashplayer/latest/help/install_flash_player.exe "$TEMP\${PRODUCT_NAME}\install_flash_player.exe"
  Pop $R0 ;Get the return value.
  StrCmp $R0 "success" +4
  MessageBox MB_OK "Erreur de tlchargement d'Adobe Flash Player NPAPI : $R0"
  DetailPrint "Erreur de tlchargement d'Adobe Flash Player NPAPI : $R0"
  Goto ActiveX
  ExecWait '"$TEMP\${PRODUCT_NAME}\install_flash_player.exe"'

ActiveX:
;Adobe Flash Player AxtiveX pour Maxthon Retro
  SetRegView 32
  ReadRegStr $1 HKLM "SOFTWARE\Macromedia\FlashPlayerActiveX" "PlayerPath"
  GetDLLVersion $1 $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $0 "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version OCX Flash Player ActiveX Windows : $0"
  ${If} ${AtLeastWin8}
    DetailPrint "Windows 8 ou plus, tlchargement d'Adobe Flash Player ActiveX inutile"
    DetailPrint "Windows Update a install la version $0"
    Goto DelTrad
  ${EndIf}
  ${VersionCompare} "$AbFlashAxVersion" $0 $1
  StrCmp $1 "0" 0 +4
  DetailPrint "Tlchargement d'Adobe Flash Player ActiveX inutile"
  DetailPrint "La dernire version $0 est dj installe"
  Goto DelTrad
  DetailPrint "Tlchargement d'Adobe Flash Player ActiveX"
  NSISdl::download http://fpdownload.adobe.com/get/flashplayer/latest/help/install_flash_player_ax.exe "$TEMP\${PRODUCT_NAME}\install_flash_player_ax.exe"
  Pop $R0 ;Get the return value.
  StrCmp $R0 "success" +4
  MessageBox MB_OK "Erreur de tlchargement d'Adobe Flash Player ActiveX : $R0"
  DetailPrint "Erreur de tlchargement d'Adobe Flash Player ActiveX : $R0"
  Goto DelTrad
  ExecWait '"$TEMP\${PRODUCT_NAME}\install_flash_player_ax.exe"'
  Goto DelTrad

DelTrad:
;Suppression des autres traductions.
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 4" "State"
  StrCmp $0 1 0 DelPDF
  DetailPrint "Suppression des autres traductions"
  StrCmp $MxVersion "Cloud" DelMxCloudTrad DelMxNGTrad

DelMxNGTrad:
  SetDetailsPrint none
  Rename $INSTDIR\Bin\Locales\all.lng $INSTDIR\Bin\Locales\all.bak
  Rename $INSTDIR\Bin\Locales\all-sample.lng $INSTDIR\Bin\Locales\all-sample.bak
  Rename $INSTDIR\Bin\Locales\en-us.lng $INSTDIR\Bin\Locales\en-us.bak
  Rename $INSTDIR\Bin\Locales\fr-fr.lng $INSTDIR\Bin\Locales\fr-fr.bak
  Delete $INSTDIR\Bin\Locales\*.lng
  Rename $INSTDIR\Bin\Locales\all.bak $INSTDIR\Bin\Locales\all.lng
  Rename $INSTDIR\Bin\Locales\all-sample.bak $INSTDIR\Bin\Locales\all-sample.lng
  Rename $INSTDIR\Bin\Locales\en-us.bak $INSTDIR\Bin\Locales\en-us.lng
  Rename $INSTDIR\Bin\Locales\fr-fr.bak $INSTDIR\Bin\Locales\fr-fr.lng
  SetDetailsPrint both
  Goto DelPDF

DelMxCloudTrad:
  SetDetailsPrint none
  Rename $INSTDIR\Language\en.ini $INSTDIR\Language\en.bak
  Rename $INSTDIR\Language\fr-fr.ini $INSTDIR\Language\fr-fr.bak
  Delete $INSTDIR\Language\*.ini
  Rename $INSTDIR\Language\en.bak $INSTDIR\Language\en.ini
  Rename $INSTDIR\Language\fr-fr.bak $INSTDIR\Language\fr-fr.ini
  SetDetailsPrint both

DelPDF:
;Suppression du plugin PDF intgr  Maxthon.
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 6" "State"
  StrCmp $0 1 0 UpdTrad
  StrCmp $MxVersion "5" UpdTrad 0
  StrCmp $MxVersion "NG" DelMxNGPDF DelMxCloudPDF

DelMxNGPDF:
  ClearErrors
  IfFileExists $INSTDIR\Core\Blink\plugins\pdf.dll 0 UpdTrad
  DetailPrint "Suppression du plugin PDF intgr  Maxthon"
  SetDetailsPrint none
  Delete $INSTDIR\Core\Blink\plugins\pdf.dll
  SetDetailsPrint both
  IfErrors 0 UpdTrad
  DetailPrint "Erreur de suppression"
  MessageBox MB_RETRYCANCEL|MB_ICONEXCLAMATION "Le plugin PDF est en cours d'utilisation. Fermer Maxthon puis Ressayer." IDRETRY DelMxNGPDF
  Goto UpdTrad

DelMxCloudPDF:
  ClearErrors
  IfFileExists $INSTDIR\Core\Webkit\pdf.dll 0 UpdTrad
  DetailPrint "Suppression du plugin PDF intgr  Maxthon"
  SetDetailsPrint none
  Delete $INSTDIR\Core\Webkit\pdf.dll
  SetDetailsPrint both
  IfErrors 0 UpdTrad
  DetailPrint "Erreur de suppression"
  MessageBox MB_RETRYCANCEL|MB_ICONEXCLAMATION "Le plugin PDF est en cours d'utilisation. Fermer Maxthon puis Ressayer." IDRETRY DelMxCloudPDF

UpdTrad:
;Tlchargement et installation des fichiers.
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 11" "State"
  StrCmp $0 0 0 UpdFlash
  StrCmp $MxVersion "Cloud" 0 UpdFiles
  DetailPrint "Tlchargement de fr-fr.zip"
  NSISdl::download http://maxthon-fr.com/site/files/fr-fr.zip "$TEMP\${PRODUCT_NAME}\fr-fr.zip"
  Pop $R0 ;Get the return value.
  StrCmp $R0 "success" +4
  MessageBox MB_OK "Erreur de tlchargement de fr-fr.zip : $R0"
  DetailPrint "Erreur de tlchargement de fr-fr.zip : $R0"
  Goto UpdFiles
  DetailPrint "Extraction de fr-fr.zip"
  nsUnzip::Extract "$TEMP\${PRODUCT_NAME}\fr-fr.zip" "/d=$TEMP\${PRODUCT_NAME}\fr-fr" /END
  Pop $R0 
  StrCmp $R0 "0" +3
  MessageBox MB_OK "Erreur d'extraction de fr-fr.zip : Erreur $R0" ;Print error message to log.
  DetailPrint "Erreur d'extraction de fr-fr.zip : Erreur $R0"
  CopyFiles "$TEMP\${PRODUCT_NAME}\fr-fr\*.*" "$INSTDIR"

UpdFiles:
  DetailPrint "Tlchargement de fr-FR.mxdic"
  NSISdl::download http://dl.maxthon.com/mx3dict/fr-FR.mxdic "$TEMP\${PRODUCT_NAME}\fr-FR.mxdic"
  Pop $R0 ;Get the return value.
  StrCmp $R0 "success" +4
  MessageBox MB_OK "Erreur de tlchargement de fr-FR.mxdic : $R0"
  DetailPrint "Erreur de tlchargement de fr-FR.mxdic : $R0"
  Goto UpdFlash
  StrCmp $MxVersion "5" 0 +4
  CopyFiles "$TEMP\${PRODUCT_NAME}\fr-FR.mxdic" "$APPDATA\Maxthon5\Public\Dicts"
  CopyFiles "$TEMP\${PRODUCT_NAME}\fr-FR.mxdic" "$INSTDIR\_AppData\Maxthon\Public\Dicts"
  Goto UpdFlash
  CopyFiles "$TEMP\${PRODUCT_NAME}\fr-FR.mxdic" "$APPDATA\Maxthon3\Public\Dicts"
  CopyFiles "$TEMP\${PRODUCT_NAME}\fr-FR.mxdic" "$INSTDIR\_AppData\Maxthon3\Public\Dicts"

UpdFlash:
;Comparer la version du plugin Flash Player sauf si l'option de suppression du plugin intgr  Maxthon est active.
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 5" "State"
  StrCmp $0 0 0 DelMxFlash
  StrCmp $MxVersion "Cloud" UpdFlashCloud UpdFlashNG

UpdFlashNG:
  SetRegView 32
  ReadRegStr $WinFlashDLLPath HKLM "SOFTWARE\Macromedia\FlashPlayerPepper" "PlayerPath"
  GetDLLVersion $WinFlashDLLPath $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $WinFlashVersion "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version DLL Flash Player PPAPI Windows : $WinFlashVersion"
  ${VersionCompare} "$WinFlashVersion" "$MxFlashVersion" $1
  StrCmp $1 "1" DelMxFlash NoFlashUpd ;Traitement de la DLL Flash uniquement si elle est plus rcente.

UpdFlashCloud:
  SetRegView 32
  ReadRegStr $WinFlashDLLPath HKLM "SOFTWARE\Macromedia\FlashPlayerPlugin" "PlayerPath"
  GetDLLVersion $WinFlashDLLPath $R0 $R1
  IntOp $R2 $R0 / 0x00010000
  IntOp $R3 $R0 & 0x0000FFFF
  IntOp $R4 $R1 / 0x00010000
  IntOp $R5 $R1 & 0x0000FFFF
  StrCpy $WinFlashVersion "$R2.$R3.$R4.$R5"
  ;MessageBox MB_ICONINFORMATION|MB_OK "Version DLL Flash Player NPAPI Windows : $WinFlashVersion"
  ${VersionCompare} "$WinFlashVersion" "$MxFlashVersion" $1
  StrCmp $1 "1" DelMxFlash End ;Traitement de la DLL Flash uniquement si elle est plus rcente.

NoFlashUpd:
  DetailPrint "Le plugin Adobe Flash Player intgr  Maxthon n'a pas t mis  jour"
  DetailPrint "Version actuelle : $MxFlashVersion"
  Goto End

DelMxFlash:
;Suppression du plugin Flash Player intgr  Maxthon.
  StrCmp $MxVersion "5" DelMx5Flash 0
  StrCmp $MxVersion "NG" DelMxNGFlash DelMxCloudFlash

DelMx5Flash:
  ClearErrors
  IfFileExists $INSTDIR\Core\plugins\pepflash*.dll 0 UpdMxFlash
  DetailPrint "Suppression du plugin Adobe Flash Player intgr  Maxthon"
  SetDetailsPrint none
  Delete "$INSTDIR\Core\plugins\pepflash*.dll"
  SetDetailsPrint both
  IfErrors 0 UpdMxFlash
  DetailPrint "Erreur de suppression"
  MessageBox MB_RETRYCANCEL|MB_ICONEXCLAMATION "Le plugin Flash Player est en cours d'utilisation. Fermer Maxthon puis Ressayer." IDRETRY DelMx5Flash
  Goto UpdMxFlash

DelMxNGFlash:
  ClearErrors
  IfFileExists $INSTDIR\Core\Blink\plugins\pepflash*.dll 0 UpdMxFlash
  DetailPrint "Suppression du plugin Adobe Flash Player intgr  Maxthon"
  SetDetailsPrint none
  Delete "$INSTDIR\Core\Blink\plugins\pepflash*.dll"
  SetDetailsPrint both
  IfErrors 0 UpdMxFlash
  DetailPrint "Erreur de suppression"
  MessageBox MB_RETRYCANCEL|MB_ICONEXCLAMATION "Le plugin Flash Player est en cours d'utilisation. Fermer Maxthon puis Ressayer." IDRETRY DelMxNGFlash
  Goto UpdMxFlash

DelMxCloudFlash:
  ClearErrors
  IfFileExists $INSTDIR\Core\Webkit\Npplugins\NPSWF*.dll 0 UpdMxFlash
  DetailPrint "Suppression du plugin Adobe Flash Player intgr  Maxthon"
  SetDetailsPrint none
  Delete "$INSTDIR\Core\Webkit\Npplugins\NPSWF*.dll"
  SetDetailsPrint both
  IfErrors 0 UpdMxFlash
  DetailPrint "Erreur de suppression"
  MessageBox MB_RETRYCANCEL|MB_ICONEXCLAMATION "Le plugin Flash Player est en cours d'utilisation. Fermer Maxthon puis Ressayer." IDRETRY DelMxCloudFlash

UpdMxFlash:
;Mise  jour du plugin Flash Player intgr  Maxthon.
  StrCmp $MxVersion "5" UpdMx5Flash 0
  StrCmp $MxVersion "NG" UpdMxNGFlash UpdMxCloudFlash

UpdMx5Flash:
  DetailPrint "Mise  jour du plugin Adobe Flash Player intgr  Maxthon"
  CopyFiles "$WinFlashDLLPath" "$INSTDIR\Core\plugins\pepflashplayer.dll"
  DetailPrint "Nouvelle version : $WinFlashVersion"
  Goto End

UpdMxNGFlash:
  DetailPrint "Mise  jour du plugin Adobe Flash Player intgr  Maxthon"
  CopyFiles "$WinFlashDLLPath" "$INSTDIR\Core\Blink\plugins\pepflashplayer.dll"
  DetailPrint "Nouvelle version : $WinFlashVersion"
  Goto End

UpdMxCloudFlash:
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 5" "State"
  StrCmp $0 0 0 End
  DetailPrint "Mise  jour du plugin Adobe Flash Player intgr  Maxthon"
  CopyFiles "$WinFlashDLLPath" "$INSTDIR\Core\Webkit\Npplugins"
  DetailPrint "Nouvelle version : $WinFlashVersion"

End:
  SetDetailsPrint none
  RMDir /r "$TEMP\${PRODUCT_NAME}"
  SetDetailsPrint both
SectionEnd

Function .onInstSuccess
;Suppression du fichier de sauvegarde des paramtres si l'option est dsactive.
  !insertmacro INSTALLOPTIONS_READ $0 "${PRODUCT_NAME}.ini" "Field 10" "State"
  StrCmp $0 0 0 +2
  Delete "$APPDATA\Maxthon3\${PRODUCT_NAME}.ini"
;Dmarrer Maxthon si l'option est active.
  !insertmacro INSTALLOPTIONS_READ $1 "${PRODUCT_NAME}.ini" "Field 8" "State"
  StrCmp $1 1 0 +2
  Exec '"$INSTDIR\Bin\Maxthon.exe"'
FunctionEnd

Section -Post
SectionEnd
